/*globals define*/
/*jslint nomen:true*/

define([
    'jquery',
    'testsuite/qunit',
    './anchorview',
    '$ready!'
], function ($, QUnit, AnchorView) {
    'use strict';

    var container = $('#qunit-fixture'),
        view,
        anchors = ['myAnchor', 'yourAnchor'];

    QUnit.module("de_epages/shop/linkpicker/anchorview", {
        setup: function () {
            view = new AnchorView();
        },
        teardown: function () {
            container.empty();
        }
    });

    QUnit.test("Linkpicker-anchorview\'s public methods", function () {
        $.each([
            'render',
            'setAnchors',
            'clearLinkData',
            '_publishAnchor'
        ], function (i, fn) {
            QUnit.deepEqual($.isFunction(view[fn]), true, "Check whether " + fn + " is a method of anchorview");
        });
    });

    QUnit.test('Check DOM', function () {
        container.append(view.render());
        view.setAnchors('#myAnchor', anchors);

        QUnit.ok(
            view.$('option[value=#myAnchor]').prop('selected'),
            'Check if anchors are passed correctly - *MyAnchor* should be selected'
        );

        view.clearLinkData();
        QUnit.equal(
            view.$('option[selected]').length,
            1,
            'Only disabled placeholder should have attribute *selected*'
        );
    });
});